/*-
 * ~~~~~~licensing~~~~~~
 * object-producer-core
 * ==========
 * Copyright (C) 2020 - 2022 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.core.producer.executor.generationmodel;

import java.util.Map;

import ru.entaxy.platform.base.objects.EntaxyObject;
import ru.entaxy.platform.core.producer.api.EntaxyProducerService;
import ru.entaxy.platform.core.producer.api.ProducerResult;
import ru.entaxy.platform.core.producer.api.ProducerResult.CommandResult;
import ru.entaxy.platform.core.producer.executor.objectmodel.FactoredObjectProxy;

public class ResolveObjectTask extends AbstractTask {

	public FactoredObjectProxy origin;
	
	public EntaxyObject targetObject;
	
	public ResolveObjectTask(FactoredObjectProxy object) {
		super();
		this.origin = object;
	}
	
	@Override
	public String getInfo() {
		return "RESOLVE-OBJECT " 
				+ "[" 
				+ origin.getObjectId() 
				+ " : " 
				+ origin.getObjectType() 
				+ "]"; 
				// + objectRef.factoryId;
	}
	@Override
	public boolean execute(ProducerResult currentResult, CommandResult currentCommand,
			EntaxyProducerService producerService, Map<String, Object> instructions) throws Exception {
		
		String targetId = origin.getObjectId();
		String targetType = origin.getObjectType();
		
		this.targetObject = ObjectResolveHelper.getInstance().findObject(targetId, targetType);
		
		if (this.targetObject == null) {
			throw new IllegalArgumentException("Object not found: " + targetId + ":" + targetType);
		}
		
		return true;
	}

}
